{
                POWER DESIGNER  V1.30   on   12 Feb 1996
  Programme d'edition et de simulation de reseaux electriques
  Utilise Power.RES, PowComp.TPW, SpeComp.TPW
          WSheet.TPW,  Ruban.TPW
          PowHelp.TPW
  appelle les versions GSP, NRP, NRPB, FDL pour WINDOWS 3.X
    au format de fichier LFI unifie,
  Transfo avec Rs et Xs (corrected 1/Zs) also Shift & Tap Transfos !
  Lignes avec Gs, Bs,
  modificateur de ligne avec racourcis Delete et Insert Point,
  controle de chargement de la version,
  affiche noms sur option, Moveable feature
  donnees pour Load Flow modified
  generation de transfo, compensator, capa data
  with protection Power.INT
  avec selection de zone rectangulaire Select Area
  et UpDate worksheet data du fichier OutName.$$$ cree par GSP,NRP,NRPB,FDL
  Help on F1 ( Contents )
  Special components for transient stability studies
    appelle TSP avec fichier TSI et out TSO et TSG for plotting !
  Affiche les defauts
  Inclue les Links ( Lignes sans Data ), les Self et Resistances !
  et les court-circuits  ????
  ---    Les calculs se font en externes qvec des DLL / BC++4.5 !
}

{$R-}
Program Power;
{$R POWER.RES }
{$D Power Designer Version 1.30}

Uses WinTypes, WinProcs, OWindows, ODialogs, Strings, Objects, WinDos,
     OStdDlgs, Win31, PowComp, WSheet;

type
    MyApplication = Object (TApplication)
    Procedure InitMainWindow; Virtual;
    procedure InitInstance; virtual;
    end;

{ methode de MyApplication }
Procedure MyApplication.InitMainWindow;
Var HGraphMenu  : HMenu;
    F           : Text;
    Cap         : LongInt;
    ValCode     : Integer;
    S           : Array [0..160] of char;
begin
PowSymbRot[Generator]:=4;
PowSymbRot[Bus]:=2;
PowSymbRot[Line]:=0;
PowSymbRot[Transfo]:=2;
PowSymbRot[Drain]:=4;
PowSymbRot[Compensator]:=4;
PowSymbRot[Capa]:=4;

PowSymbRot[Resistance]:=2;
PowSymbRot[SelfInd]:=2;
PowSymbRot[Link]:=0;

PowSymbImage[Generator,0]:=LoadBitMap(HInstance,'Generator0');
PowSymbImage[Generator,1]:=LoadBitMap(HInstance,'Generator1');
PowSymbImage[Generator,2]:=LoadBitMap(HInstance,'Generator2');
PowSymbImage[Generator,3]:=LoadBitMap(HInstance,'Generator3');

PowSymbImage[Compensator,0]:=LoadBitMap(HInstance,'Compensator0');
PowSymbImage[Compensator,1]:=LoadBitMap(HInstance,'Compensator1');
PowSymbImage[Compensator,2]:=LoadBitMap(HInstance,'Compensator2');
PowSymbImage[Compensator,3]:=LoadBitMap(HInstance,'Compensator3');

PowSymbImage[Bus,0]:=LoadBitMap(HInstance,'Bus0');
PowSymbImage[Bus,1]:=LoadBitMap(HInstance,'Bus1');

PowSymbImage[Line,0]:=LoadBitMap(HInstance,'Line');

PowSymbImage[Transfo,0]:=LoadBitMap(HInstance,'Transfo0');
PowSymbImage[Transfo,1]:=LoadBitMap(HInstance,'Transfo1');

PowSymbImage[Drain,0]:=LoadBitMap(HInstance,'Drain0');
PowSymbImage[Drain,1]:=LoadBitMap(HInstance,'Drain1');
PowSymbImage[Drain,2]:=LoadBitMap(HInstance,'Drain2');
PowSymbImage[Drain,3]:=LoadBitMap(HInstance,'Drain3');

PowSymbImage[Capa,0]:=LoadBitMap(HInstance,'Capa0');
PowSymbImage[Capa,1]:=LoadBitMap(HInstance,'Capa1');
PowSymbImage[Capa,2]:=LoadBitMap(HInstance,'Capa2');
PowSymbImage[Capa,3]:=LoadBitMap(HInstance,'Capa3');

FaultImage:=LoadBitMap(HInstance,'ThreePhaseFault');

PowSymbImage[Resistance,0]:=LoadBitMap(HInstance,'Resistance0');
PowSymbImage[Resistance,1]:=LoadBitMap(HInstance,'Resistance1');

PowSymbImage[SelfInd,0]:=LoadBitMap(HInstance,'SelfInd0');
PowSymbImage[SelfInd,1]:=LoadBitMap(HInstance,'SelfInd1');

PowSymbImage[Link,0]:=LoadBitMap(HInstance,'Link');

HGraphMenu:=LoadMenu(Hinstance,'PowerMenu');
ModifyMenu( HGraphMenu, cm_Generator, MF_BYCOMMAND+MF_BitMap, cm_Generator,
             MakeLP(PowSymbImage[Generator,0],0) );
ModifyMenu( HGraphMenu, cm_Bus, MF_BYCOMMAND+MF_BitMap, cm_Bus,
             MakeLp(PowSymbImage[Bus,0],0) );
ModifyMenu( HGraphMenu, cm_Line, MF_BYCOMMAND+MF_BitMap, cm_Line,
             MakeLp(PowSymbImage[Line,0],0) );
ModifyMenu( HGraphMenu, cm_Transfo, MF_BYCOMMAND+MF_BitMap, cm_Transfo,
             MakeLp(PowSymbImage[Transfo,0],0) );
ModifyMenu( HGraphMenu, cm_Drain, MF_BYCOMMAND+MF_BitMap, cm_Drain,
             MakeLp(PowSymbImage[Drain,0],0) );
ModifyMenu( HGraphMenu, cm_Compensator, MF_BYCOMMAND+MF_BitMap,
             cm_Compensator, MakeLp(PowSymbImage[Compensator,0],0) );
ModifyMenu( HGraphMenu, cm_Capa, MF_BYCOMMAND+MF_BitMap, cm_Capa,
             MakeLp(PowSymbImage[Capa,0],0) );

ModifyMenu( HGraphMenu, cm_SelfInd, MF_BYCOMMAND+MF_BitMap, cm_SelfInd,
             MakeLp(PowSymbImage[SelfInd,0],0) );
ModifyMenu( HGraphMenu, cm_Resistance, MF_BYCOMMAND+MF_BitMap, cm_Resistance,
             MakeLp(PowSymbImage[Resistance,0],0) );
ModifyMenu( HGraphMenu, cm_Link, MF_BYCOMMAND+MF_BitMap, cm_Link,
             MakeLp(PowSymbImage[Link,0],0) );

MainWindow:= New(PDesigner, Init( 'Power Designer', HGraphMenu));
end;

procedure MyApplication.InitInstance;
begin
  TApplication.InitInstance;
{ Permet a une seule copie de Power Designer de fonctionner a la fois
  if HPrevInst<>0 then Status:=em_InvalidMainWindow;
}
  if Status = 0 then
  begin
    HAccTable := LoadAccelerators(HInstance, 'PowerAccel');
    if HAccTable = 0 then
      Status := em_InvalidWindow;
  end;
end;

procedure ShowSplashScreen(var R: TRect);
var
  BM: HBitmap;
  DC, MemDC: HDC;
  BitInfo: TBitmap;
begin
  DC := GetDC(0);
  MemDC := CreateCompatibleDC(DC);
  BM := LoadBitmap(HInstance, 'ImageHT');
  GetObject(BM, SizeOf(BitInfo), @BitInfo);
  BM := SelectObject(MemDC, BM);   { swap BMs}
  R.Left := GetDeviceCaps(DC,HORZRES) div 2 - BitInfo.bmWidth div 2;
  R.Top := GetDeviceCaps(DC,VERTRES) div 2 - BitInfo.bmHeight div 2;
  BitBlt(DC, R.Left, R.Top, BitInfo.bmWidth, BitInfo.bmHeight,
         MemDC, 0, 0, SrcCopy);
  DeleteObject(SelectObject(MemDC, BM));
  DeleteDC(MemDC);
  ReleaseDC(0, DC);
  R.Right := R.Left + BitInfo.bmWidth;
  R.Bottom := R.Top + BitInfo.bmHeight;
end;


var  MyApp : MyApplication;
     Re: TRect;

Begin
{ Show Splash screen BitMap }
  ShowSplashScreen(Re);
MyApp.Init('Power');
{ Erase the splash bitmap }
  InvalidateRect(0, @Re, True);
MyApp.Run;
MyApp.Done;
End.
