//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "loadflow.h"
#include "transtab.h"

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
        Application->MessageBox("Programed by Lotfi BAGHLI\n\n\nJune 1999",
				"About Luncher", MB_OK | MB_ICONINFORMATION);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
        OpenDialog->Filter = "Load Flow Input (*.LFI)|*.lfi|Trans Stab Input (*.TSI)|*.tsi|";
        OpenDialog->Options << ofFileMustExist << ofHideReadOnly << ofNoReadOnlyReturn;
	if (OpenDialog->Execute())
	{
        sprintf( FileName, "%s", OpenDialog->FileName);
	}
/*
  TOpenSaveDialog::TData data (
	 OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_NOREADONLYRETURN,
	 "Load Flow Input (*.LFI)|*.lfi|Trans Stab Input (*.TSI)|*.tsi|",
	 0,
	 "",
	 "LFI|TSI"
  );
  if (TFileOpenDialog(this, data).Execute() == IDOK) {
//	 char fileTitle[MAXPATH];
	 TOpenSaveDialog::GetFileTitle(data.FileName, FileName, MAXPATH);
	 // call init all things sauf ceux de simul
	 UpdateCaption();
	 }

// open
  if(OpenFileDialog->Execute()){
	 EditForm=new TEditForm(this);
	 EditForm->Open(OpenFileDialog->FileName);
  }
void __fastcall TEditForm::Open(const AnsiString AFileName)
{
	PathName = AFileName;
	Caption = ExtractFileName(AFileName);
	Editor->Lines->LoadFromFile(PathName);
	Editor->SelStart = 0;
	Editor->Modified = false;
}

void __fastcall TEditForm::Saveas1Click(TObject *Sender)
{
  SaveFileDialog->FileName = PathName;
  if (SaveFileDialog->Execute() ){
    PathName= SaveFileDialog->FileName;
    Caption = ExtractFileName(PathName);
    Save1Click(Sender);
  }
}




// save

*/
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GaussSeidel1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("LoadFlow.exe ");
	SS+=id_GS;
        SS+=" ";
	SS+=FileName;
        SS+=" out.lfo";
//       Application->MessageBox( SS.c_str(), "Caller", MB_OK);
 	WinExec( SS.c_str(), SW_SHOW);
	}
//	LoadFlow( id_GS, FileName, "out.lfo");
}
//---------------------------------------------------------------------------



void __fastcall TForm1::View1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	char SS[MAXPATH];
	strcpy( SS, "notepad.exe ");
	strcat( SS, FileName);
	WinExec( SS, SW_SHOW);
	}
}
//---------------------------------------------------------------------------




void __fastcall TForm1::NewtonRaphson1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("LoadFlow.exe ");
	SS+=id_NR;
        SS+=" ";
	SS+=FileName;
        SS+=" out.lfo";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	LoadFlow( id_NR, FileName, "out.lfo");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewtonRaphsonwithBackoff1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("LoadFlow.exe ");
	SS+=id_NRB;
        SS+=" ";
	SS+=FileName;
        SS+=" out.lfo";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	LoadFlow( id_NRB, FileName, "out.lfo");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FDL1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("LoadFlow.exe ");
	SS+=id_FDL;
        SS+=" ";
	SS+=FileName;
        SS+=" out.lfo";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	LoadFlow( id_FDL, FileName, "out.lfo");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Euler1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("Transtab.exe ");
	SS+=id_Euler;
        SS+=" ";
	SS+=FileName;
        SS+=" out.tso Graph.tsg";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	TransStab( id_Euler, FileName, "out.tso", "Graph.tsg");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Trapeze1Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("Transtab.exe ");
	SS+=id_Trapeze;
        SS+=" ";
	SS+=FileName;
        SS+=" out.tso Graph.tsg";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	TransStab( id_Trapeze, FileName, "out.tso", "Graph.tsg");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RK41Click(TObject *Sender)
{
if (strcmp(FileName, ""))
	{
	AnsiString SS("Transtab.exe ");
	SS+=id_RK4;
        SS+=" ";
	SS+=FileName;
        SS+=" out.tso Graph.tsg";
	WinExec( SS.c_str(), SW_SHOW);
	}
//	TransStab( id_RK4, FileName, "out.tso", "Graph.tsg");
}
//---------------------------------------------------------------------------

