//---------------------------------------------------------------------------
#include <vcl.h>

#include "loadflow.h"

//#include "lf.h"
#ifndef __GS_H
#include "gs.h"
#endif

#ifndef __NR_H
#include "nr.h"
#endif

#ifndef __NRB_H
#include "nrb.h"
#endif

#ifndef __FDL_H
#include "fdl.h"
#endif

#pragma hdrstop
USERES("loadflow.res");
USEFORM("Progress.cpp", ProgressForm);
USEUNIT("gs.cpp");
USEUNIT("lf.cpp");
USEUNIT("nr.cpp");
USEUNIT("nrb.cpp");
USEUNIT("fdl.cpp");
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR lpCmdLine, int)
{
        try
        {
                 Application->Initialize();
                 Application->Run();
        if (ParamCount()==3)
          {
          AnsiString SS( LowerCase(ParamStr(1)));
          int LFint=SS.ToInt();
          AnsiString InN( LowerCase(ParamStr(2)));
          AnsiString OutN( LowerCase(ParamStr(3)));
          CallLoadFlow( LFint, InN.c_str(), OutN.c_str());
          }

        }


        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
        return 0;
}
//---------------------------------------------------------------------------


/*  Programme de calcul d'ecoulement de puissance
	 Pour Power Designer V1.40
	 Pour BC++ Builder 4 et sous Windows ( DLL functions )
*/

// Load flow function
int CallLoadFlow( int LFint, char * InN, char * OutN)
{
/*
Application->MessageBox("Hi I am Called !!\n\nProgramed by Lotfi BAGHLI\n\n\nJune 1999",
				"About DLL Called", MB_OK | MB_ICONINFORMATION);
*/
//BOOL far _export pascal
//	CallLoadFlow( TWindow * Parent, int LFint, char * InN, char * OutN )

/*  TWindow* parentAlias = GetWindowPtr(parentHWnd);  // check if an OWL window
  if (!parentAlias)
	 parentAlias = new TWindow(parentHWnd, ::Module);
*/
TLF * LFProg;
  switch( LFint)
	{
	case id_GS :	LFProg=new TGS( InN, OutN); break;
	case id_NR :	LFProg=new TNR( InN, OutN); break;
	case id_NRB :	LFProg=new TNRB( InN, OutN); break;
	case id_FDL :	LFProg=new TFDL( InN, OutN); break;
	default :	return AllocError;
	}
if (LFProg==NULL) {
                Application->MessageBox( "Out of memory error",
                                "Error in calling the Load Flow Program",
				MB_OK+MB_ICONEXCLAMATION);
				exit(1);
				}
// LFType=LFint
LFProg->Lecture();
//	Application->MessageBox( "Lecture OK", "LOAD FLOW PROGRAM", MB_OK);
LFProg->Run();
//	Application->MessageBox( "Run OK", "LOAD FLOW PROGRAM", MB_OK);

int ReturnFlag=LFProg->IsItOK();
// cette ligne cause pb
//delete LFProg;

	char SS[MAXPATH];
	strcpy( SS, "notepad.exe ");
	strcat( SS, OutN);
	WinExec( SS, SW_SHOW);

return ReturnFlag;
}